/*
 *  TOPPERS ECHONET Lite Communication Middleware
 *
 *  Copyright (C) 2017 Cores Co., Ltd. Japan
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  @(#) $Id: httpd.h 270 2017-02-09 04:03:47Z coas-nagasima $
 */

#ifndef __HTTPD_H__
#define __HTTPD_H__

#include "httpd-fs.h"
#include "http_parser.h"
#include "websocket.h"

#define MAX_ELEMENT_SIZE 256

struct message {
	enum http_method method;
	unsigned short http_major;
	unsigned short http_minor;
	char filename[64];
	char request_url[MAX_ELEMENT_SIZE];
	char response_status[64];
	int num_headers;
	char host[MAX_ELEMENT_SIZE];
	char referer[MAX_ELEMENT_SIZE];
	char upgrade[32];
	char connection[32];
	char sec_websocket_key[64];
	char origin[MAX_ELEMENT_SIZE];
	char sec_websocket_protocol[64];
	char sec_websocket_version[4];
	char response_key[86];
	size_t body_size;
	int should_keep_alive;
	int headers_complete_cb_called;
	int message_begin_cb_called;
	int message_complete_cb_called;
	int body_is_final;
};

#ifndef _MSC_VER
size_t strnlen(const char *s, size_t maxlen);
#endif
size_t strlncat(char *dst, size_t len, const char *src, size_t n);
extern http_parser_settings websvr_settings;

typedef enum httpd_state_t {
	STATE_DISCONNECTED,		/* ؒf */
	STATE_CONNECTED,		/* ڑ */
	STATE_WEBSOCKET,		/* WebSocketʐM */
	STATE_CLOSING,			/* ؒf */
	STATE_RESET,			/* mrubyN̂߂̃Zbg */
} httpd_state_t;

typedef enum httpd_in_state_t {
	IN_STATE_START,
	IN_STATE_REQUEST,
	IN_STATE_UPLOAD,
	IN_STATE_UPLOAD_WAIT,
	IN_STATE_RESPONSE,
	IN_STATE_WEBSOCKET,
	IN_STATE_END,
} httpd_in_state_t;

typedef enum httpd_out_state_t {
	OUT_STATE_WAIT_REQUEST,
	OUT_STATE_OPEN_GET_FILE,
	OUT_STATE_WAIT_POST_BODY,
	OUT_STATE_BODY_RECEIVED,
	OUT_STATE_SEND_HEADER,
	OUT_STATE_SEND_FILE,
	OUT_STATE_SEND_DATA,
	OUT_STATE_SEND_END,
} httpd_out_state_t;

struct httpd_state {
	ID tskid;
	ID cepid;
	uint8_t dst[20];
	char temp[16];
	char addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
	httpd_state_t state;
	int reset;
	struct {
		httpd_in_state_t state;
		bool_t wait;
		char *data;
		SYSTIM timer;
	} in;
	struct {
		httpd_out_state_t state;
		bool_t wait;
		const char *statushdr;
	} out;
	struct {
		int parse_pos;
		int parse_len;
		struct http_parser parser;
		struct http_parser_url handle;
		struct message message;
	};
	union {
		struct {
			char *filename;
			char *query;
			struct httpd_fs_file file;
		};
		struct {
			char *_dummy_filename;
			const char *response_body;
			int response_pos;
			int response_len;
		};
		struct {
			struct websocket websocket;
			int close_req;
		};
	};
};
#define get_context(p) (struct httpd_state *)((intptr_t)p - (intptr_t)&((struct httpd_state *)0)->parser)

#endif /* __HTTPD_H__ */
